CARGO-TEST(1)

NAME
cargo-test - Execute unit and integration tests of a package

SYNOPSIS

cargo test [OPTIONS] [TESTNAME] [-- TEST-OPTIONS]

DESCRIPTION

Compile and execute unit and integration tests.

The test filtering argument TESTNAME and all the arguments following the two dashes (--) are passed to the test binaries and thus to libtest (rustc’s built in unit-test and micro-benchmarking framework). If you’re passing arguments to both Cargo and the binary, the ones after -- go to the binary, the ones before go to Cargo. For details about libtest’s arguments see the output of cargo test — --help. As an example, this will run all tests with foo in their name on 3 threads in parallel:

    cargo test foo -- --test-threads 3

Tests are built with the --test option to rustc which creates an executable with a main function that automatically runs all functions annotated with the #[test] attribute in multiple threads. #[bench] annotated functions will also be run with one iteration to verify that they are functional.

The libtest harness may be disabled by setting harness = false in the target manifest settings, in which case your code will need to provide its own main function to handle running tests.

Documentation tests are also run by default, which is handled by rustdoc. It extracts code samples from documentation comments and executes them. See the for more information on writing doc tests.

OPTIONS

  Test Options

--no-run
    Compile, but don’t run tests.

--no-fail-fast
    Run all tests regardless of failure. Without this flag, Cargo will exit after the first executable fails. The Rust test harness will run all tests within the executable to completion, this flag only applies to the executable as a whole.

  Package Selection

By default, when no package selection options are given, the packages selected depend on the current working directory. In the root of a virtual workspace, all workspace members are selected (--all is implied). Otherwise, only the package in the current directory will be selected. The default packages may be overridden with the workspace.default-members key in the root Cargo.toml manifest.

-p SPEC..., --package SPEC...
    Test only the specified packages. See cargo-pkgid(1) for the SPEC format. This flag may be specified multiple times.

--all
    Test all members in the workspace.

--exclude SPEC...
    Exclude the specified packages. Must be used in conjunction with the --all flag. This flag may be specified multiple times.

  Target Selection

When no target selection options are given, cargo test will build the following targets of the selected packages:

    • lib — used to link with binaries, examples, integration tests, and doc tests

    • bins (only if integration tests are built and required features are available)

    • examples — to ensure they compile

    • lib as a unit test

    • bins as unit tests

    • integration tests

    • doc tests for the lib target

The default behavior can be changed by setting the test flag for the target in the manifest settings. Setting examples to test = true will build and run the example as a test. Setting targets to test = false will stop them from being tested by default. Target selection options that take a target by name ignore the test flag and will always test the given target.

Doc tests for libraries may be disabled by setting doctest = false for the library in the manifest.

Passing target selection flags will test only the specified targets.

--lib
    Test the package’s library.

--bin NAME...
    Test the specified binary. This flag may be specified multiple times.

--bins
    Test all binary targets.

--example NAME...
    Test the specified example. This flag may be specified multiple times.

--examples
    Test all example targets.

--test NAME...
    Test the specified integration test. This flag may be specified multiple times.

--tests
    Test all targets in test mode that have the test = true manifest flag set. By default this includes the library and binaries built as unittests, and integration tests. Be aware that this will also build any required dependencies, so the lib target may be built twice (once as a unittest, and once as a dependency for binaries, integration tests, etc.). Targets may be enabled or disabled by setting the test flag in the manifest settings for the target.

--bench NAME...
    Test the specified benchmark. This flag may be specified multiple times.

--benches
    Test all targets in benchmark mode that have the bench = true manifest flag set. By default this includes the library and binaries built as benchmarks, and bench targets. Be aware that this will also build any required dependencies, so the lib target may be built twice (once as a benchmark, and once as a dependency for binaries, benchmarks, etc.). Targets may be enabled or disabled by setting the bench flag in the manifest settings for the target.

--all-targets
    Test all targets. This is equivalent to specifying --lib --bins --tests --benches --examples.

--doc
    Test only the library’s documentation. This cannot be mixed with other target options.

  Feature Selection

When no feature options are given, the default feature is activated for every selected package.

--features FEATURES
    Space or comma separated list of features to activate. These features only apply to the current directory’s package. Features of direct dependencies may be enabled with <dep-name>/<feature-name> syntax.

--all-features
    Activate all available features of all selected packages.

--no-default-features
    Do not activate the default feature of the current directory’s package.

  Compilation Options

--target TRIPLE
    Test for the given architecture. The default is the host architecture. The general format of the triple is <arch><sub>-<vendor>-<sys>-<abi>. Run rustc --print target-list for a list of supported targets.

    This may also be specified with the build.target

--release
    Test optimized artifacts with the release profile. See the PROFILES section for details on how this affects profile selection.

  Output Options

--target-dir DIRECTORY
    Directory for all generated artifacts and intermediate files. May also be specified with the CARGO_TARGET_DIR environment variable, or the build.target-dir Defaults to target in the root of the workspace.

  Display Options

By default the Rust test harness hides output from test execution to keep results readable. Test output can be recovered (e.g., for debugging) by passing --nocapture to the test binaries:

    cargo test -- --nocapture

-v, --verbose
    Use verbose output. May be specified twice for "very verbose" output which includes extra output such as dependency warnings and build script output. May also be specified with the term.verbose

-q, --quiet
    No output printed to stdout.

--color WHEN
    Control when colored output is used. Valid values:

        • auto (default): Automatically detect if color support is available on the terminal.

        • always: Always display colors.

        • never: Never display colors.

    May also be specified with the term.color

--message-format FMT
    The output format for diagnostic messages. Valid values:

        • human (default): Display in a human-readable text format.

        • json: Emit JSON messages to stdout.

        • short: Emit shorter, human-readable text messages.

  Manifest Options

--manifest-path PATH
    Path to the Cargo.toml file. By default, Cargo searches in the current directory or any parent directory for the Cargo.toml file.

--frozen, --locked
    Either of these flags requires that the Cargo.lock file is up-to-date. If the lock file is missing, or it needs to be updated, Cargo will exit with an error. The --frozen flag also prevents Cargo from attempting to access the network to determine if it is out-of-date.

    These may be used in environments where you want to assert that the Cargo.lock file is up-to-date (such as a CI build) or want to avoid network access.

--offline
    Prevents Cargo from accessing the network for any reason. Without this flag, Cargo will stop with an error if it needs to access the network and the network is not available. With this flag, Cargo will attempt to proceed without the network if possible.

    Beware that this may result in different dependency resolution than online mode. Cargo will restrict itself to crates that are downloaded locally, even if there might be a newer version as indicated in the local copy of the index. See the cargo-fetch(1) command to download dependencies before going offline.

    May also be specified with the net.offline

  Common Options

-h, --help
    Prints help information.

-Z FLAG...
    Unstable (nightly-only) flags to Cargo. Run cargo -Z help for details.

  Miscellaneous Options

The --jobs argument affects the building of the test executable but does not affect how many threads are used when running the tests. The Rust test harness includes an option to control the number of threads used:

    cargo test -j 2 -- --test-threads=2

-j N, --jobs N
    Number of parallel jobs to run. May also be specified with the build.jobs Defaults to the number of CPUs.

PROFILES

Profiles may be used to configure compiler options such as optimization levels and debug settings. See for more details.

Profile selection depends on the target and crate being built. By default the dev or test profiles are used. If the --release flag is given, then the release or bench profiles are used.
Target | Default Profile | --release Profile
lib, bin, example | dev | release
test, bench, or any target in "test" or "bench" mode | test | bench

Dependencies use the dev/release profiles.

Unit tests are separate executable artifacts which use the test/bench profiles. Example targets are built the same as with cargo build (using the dev/release profiles) unless you are building them with the test harness (by setting test = true in the manifest or using the --example flag) in which case they use the test/bench profiles. Library targets are built with the dev/release profiles when linked to an integration test, binary, or doctest.

ENVIRONMENT

See for details on environment variables that Cargo reads.

EXIT STATUS

0
    Cargo succeeded.

101
    Cargo failed to complete.

EXAMPLES

    1. Execute all the unit and integration tests of the current package:

        cargo test

    2. Run only a specific test within a specific integration test:

        cargo test --test int_test_name -- modname::test_name

SEE ALSO

cargo(1), cargo-bench(1)